/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
	Header file containing common stuff needed across all modules
	Created by fink, Oct 26, 2002
*/

#ifndef POOP_EM_UP_COMMON_HEADER
#define POOP_EM_UP_COMMON_HEADER

// fink: precompiler likes integers
#define WINDOWS 0

#if(WINDOWS)
// WINDOWS/DevStudio SPECIFIC
#include <glut.h>
#define STDCALL __stdcall
#else
// LINUX SPECIFIC
#include <GL/glut.h>
#define STDCALL 
#endif

#include <iostream.h>
#include "includes/base/myDisplayLists.h"
#include "myTimeStats.h"

#define PI 3.14159265358

extern unsigned long frameCount;
extern unsigned long currTime;

extern myDisplayLists displayLists;
extern myTimeStats	  timeStats;

#define GET_CURRENT_SECOND (currTime/CLOCKS_PER_SEC)

//Set to 1 if game seams slow on your puter.
extern unsigned short FAST_COMPUTER; 
extern int POOP_TEXTURE_2D;
extern int POOP_SHOW_CLOUDS;
extern int POOP_SHOW_TREES;
extern unsigned short POOP_WINDOW_MODE;
extern unsigned short POOP_LIGHTING;
extern unsigned short POOP_GAME_SPEED; // for controlling fps

extern GLuint POOP_SHADING_TYPE;

#endif // !defined POOP_EM_UP_COMMON_HEADER 









