/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/***************************************************************************
                          my3dpoint.h  -  description
                             -------------------
    begin                : Tue Oct 15 2002
    copyright            : (C) 2002 by Sherif Zaroubi
    email                : fogof@localhost.localdomain
 ***************************************************************************/

#ifndef MY3DPOINT_H
#define MY3DPOINT_H

/**
 *@author Sherif Zaroubi
 */

/**
 * DESCRIBS A 4d Point in a 3d World
 */


#include "myVector.h"
#include "../../common.h"

class my3dPoint {
  private:
    GLfloat points[4];

  public:
    my3dPoint();
    ~my3dPoint();

    float getX() {
	return points[0];
    }
    float getY() {
	return points[1];
    }
    float getZ() {
	return points[2];
    }
    float getW() {
	return points[3];
    }

    float getElement(int i) {
      if ((i < 4) && (i >= 0))
	return points[i];
      else
	return -99999;	// 5 - 9's
    }
    void setElement(int i, float value) {
      if ((i < 4) && (i >= 0))
	points[i] = value;
    }
    
    void operator = (my3dPoint p);
    
    
    void print();
    
    void setXYZ(float tx, float ty, float tz) {
      setX(tx);
      setY(ty);
      setZ(tz);
    }
    void setXYZW(GLfloat tx, GLfloat ty, GLfloat tz, GLfloat tw) {
      setX(tx);
      setY(ty);
      setZ(tz);
      setW(tw);
    }
    void setX(float t) {
      points[0] = t;
    }
    void setY(float t) {
      points[1] = t;
    }
    void setZ(float t) {
      points[2] = t;
    }
    void setW(float t) {
      points[3] = t;
    }
    
    
    my3dPoint operator + (my3dPoint & rhs);
    my3dPoint operator + (myVector v);
    
};

void my3dPoint::operator = (my3dPoint p) {
  setXYZW(p.getX(), p.getY(), p.getZ(), p.getW());
}

my3dPoint::my3dPoint()
{
  setXYZW(0, 0, 0,1);
}

my3dPoint::~my3dPoint()
{
}

my3dPoint my3dPoint::operator + (my3dPoint & rhs) {
  my3dPoint temp;
  
  temp.setXYZ(getX() + rhs.getX(), getY() + rhs.getY(),
	      getZ() + rhs.getZ());
  return temp;
}

my3dPoint my3dPoint::operator + (myVector rhs) {
  my3dPoint temp;
  
  temp.setXYZ(getX() + rhs.getX(), getY() + rhs.getY(),
	      getZ() + rhs.getZ());
  return temp;
}


void my3dPoint::print()
{
  cout << "X:" << getX() << " |Y: " << getY() << "|Z: " << getZ() <<
    "| W:" << getW() << " " << endl;
  
}


#endif
