/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MYCOLOR_H
#define MYCOLOR_H

class myColor{

 public:
  float r,g,b,a; //Values in [0,1]
	void setRGBA(float tr, float tg, float tb, float ta);
  myColor(){r=g=b=a=1;}
  ~myColor(){}
  myColor(float tr, float tg, float tb, float ta){
	setRGBA(tr,tg,tb,ta);
  }
  myColor operator + (myColor  rhs) ;
  myColor operator - (myColor  rhs) ;

  myColor interpolate (myColor c2, float percentage);
};


void myColor::setRGBA(float tr, float tg, float tb, float ta){
	r=tr;g=tg;b=tb;a=ta;
}

myColor myColor::interpolate(myColor c2, float percentage){
	//Percentage: when100% -> c2 is returned
	// 0% -> thisColor is returned
	myColor returnVal;

  returnVal.r = (c2.r - r) * percentage/100 + r;
  returnVal.g = (c2.g - g) * percentage/100 + g;
  returnVal.b = (c2.b - b) * percentage/100 + b;
  returnVal.a = (c2.b - a) * percentage/100 + a;
  return returnVal;
}


myColor myColor::operator + (myColor  rhs) {
  myColor temp;
  
  temp.setRGBA(
		r + rhs.r, 
		g + rhs.g, 
		b + rhs.b, 
		a + rhs.a
		);
  return temp;
}

myColor myColor::operator - (myColor  rhs) {
  myColor temp;
  
  temp.setRGBA(
		r - rhs.r, 
		g - rhs.g, 
		b - rhs.b, 
		a - rhs.a
		);
  return temp;
}


#endif
