/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* class for managing the display lists */

#ifndef POOP_EM_UP_DISPLAYLISTS_H
#define POOP_EM_UP_DISPLAYLISTS_H

#include "../../common.h"

#define NUM_WINDOWS 2
#define MAX_DL      2000

class myDisplayLists
{
 protected:
  
  GLint list[NUM_WINDOWS][MAX_DL];
  GLint window_ids[NUM_WINDOWS];
  
  int cnt;
  int cur_window;
  
 public:
  myDisplayLists() 
    {
      cnt = 0;
      cur_window = 0;
      
    }
  
  void CreateAllLists()
    {
      // generate a bunch of lists please
      GLuint n,i,j;
      n = glGenLists(MAX_DL * NUM_WINDOWS);
      for(i = 0; i < NUM_WINDOWS; ++i)
	{
	  for(j = 0; j < MAX_DL; ++j)
	    {
	      list[i][j] = n++;
	    }
	}
    }
  
  int CreateNewList()
    {
      ++cnt;
      return cnt;
    }
  
  void setWindow(int id, int window_id)
    {
      window_ids[id] = window_id;
    }
  
  void SetCurrWindow(int window)
    {
      cur_window = window;
      glutSetWindow(window_ids[window]);
    }  
  
  GLint getList(int id)
    {
      GLint l = list[cur_window][id];
      return l;
    }
  int getWindowId(int displayListId){
    return window_ids[displayListId];
  }
  
};


#endif






