/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MYLIGHT_H
#define MYLIGHT_H

#include "../../common.h"

/**
  *@author Sherif Zaroubi
  */

class myLight {
	private:
		GLfloat position[4];
  		GLfloat direction[3];
  		GLenum lightId;

   	public:

		myLight();
		~myLight();

  		void moveTo(GLfloat x, GLfloat y, GLfloat z);
  		void moveBy(GLfloat x, GLfloat y, GLfloat z);

		void disable(){glDisable(lightId);}
  		void enable(){glEnable(lightId);}

    	void lookAt(GLfloat,GLfloat,GLfloat);
		void moveLookAtBy(GLfloat x, GLfloat y, GLfloat z);
     	
  		void init(GLenum);
		void draw();
};

myLight::myLight(){
  		if ( POOP_LIGHTING ) glEnable(GL_LIGHTING);	
		lookAt(500,500,0);
    	moveTo(500,500,500);
}

myLight::~myLight(){
}

void myLight::init(GLenum tLightId){
	
	lightId = tLightId;	
	glEnable(tLightId);
	//cout<<"Light initialized"<<endl;

}

void myLight::draw(){
  /*
    GLfloat ambiant_and_defuse[] = { 1.0, 1.0, 1.0, 1.0};
    GLfloat specular[] = { 1.0, 1.0, 1,.0, 1.0};
    GLfloat shiny[] = { 100.0};
  */
  GLfloat exp[] = { 1.0, 1.0, 0.0, 1.0};
  
  
  glShadeModel(POOP_SHADING_TYPE);
  
  /*
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, ambiant_and_defuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, specular);
    glMaterialfv(GL_FRONT, GL_SHININESS, shiny);
  */
  glLightfv(lightId, GL_SPOT_EXPONENT, exp);
  //glLightf(lightId, GL_SPOT_CUTOFF,5);  //Dont get why that does'nt work
  //glLightf(lightId, GL_LINEAR_ATTENUATION, 8);
  
  glLightfv(lightId, GL_SPOT_DIRECTION, direction);
  glLightfv(lightId, GL_POSITION, position);
  
  glEnable(GL_COLOR_MATERIAL);
  //glEnable(GL_DEPTH_TEST);
  

}

void myLight::moveTo(GLfloat x, GLfloat y, GLfloat z){
	position[0] = x;
 	position[1] = y;
 	position[2] = z;
	position[3] = 1;

}

void myLight::moveBy(GLfloat x, GLfloat y, GLfloat z){
	moveTo(position[0] + x, position[1] + y , position[2] + z);
}

void myLight::lookAt(GLfloat x, GLfloat y, GLfloat z){
	direction[0] = x;
 	direction[1] = y;
 	direction[2] = z;

}
void myLight::moveLookAtBy(GLfloat x, GLfloat y, GLfloat z){
	lookAt(x + direction[0],  y + direction[1], z + direction[2]);
}

#endif

