/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MYPOOP_H
#define MYPOOP_H

/* Start the childish humor about my poop ie:
 * myPoop.isStinky() == true no matter what
 * myPoop.setColor(.5,.5,0) //brownish color
 * so on an so forth
 */

#include "../base/myObject2.h"
#include "../base/myVector.h"
#include "../../common.h"
#include "../base/my3dPoint.h"

#define GRAVITY -1

class myPoop: public myObject2{
 private:
  my3dPoint destination;
  myVector speed;
  myVector accel;
  myVector resistance;
  myVector gravityVect;
  
 public:
  myPoop(){ 
    init();
  }
  
  myVector getGravity(){return gravityVect;}

  void drop(my3dPoint launchPos, my3dPoint tdest);

  void init(){
    resetState();
    scaleBy(50,50,50);
    setColor(.5,.22567,0);
    resistance.setXYZ(-1,-1,0);
    gravityVect.setXYZ(0,0,GRAVITY);

  }

  ~myPoop(){};
  void setAccel(myVector t){accel = t;}
  void setAccel(float x, float y, float z){
    myVector t;
    t.setXYZ(x,y,z);
    setAccel(t);
  }

  void animate(){
    speed = speed + accel + gravityVect;
    accel = accel;
    translateBy(speed);
  }

  void drawGeometry(){
    glutSolidSphere(1,20,20);
  }
};

// set up a list type for poop
typedef list<myPoop*> POOP_LIST; 


void myPoop::drop(my3dPoint launchPos, my3dPoint tdest){

  resetState();
  translateBy(
	      launchPos.getX(),
	      launchPos.getY(),
	      launchPos.getZ()
	      );

  destination = tdest;
  accel.setXYZ(
	       destination.getX() - launchPos.getX(),
	       destination.getY() - launchPos.getY(),
	       destination.getZ() - launchPos.getZ()
	       );
  accel = accel.normalize();

  scaleBy(30,30,50);
  resistance.setXYZ(-1,-1,0);

}


#endif
