/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/***************************************************************************
                          nic
 ***************************************************************************/


#ifndef MYCROSSAIR_H
#define MYCROSSAIR_H

#include "../base/myObject2.h"


class myCrossAir : public myObject2  {
 public:
  myCrossAir();
  ~myCrossAir();
  void drawGeometry();
  
  GLfloat getWidth(){ return 1;}
  GLfloat getHeight(){ return 1;}
  float rotator,lines;
};

myCrossAir::myCrossAir(){
  
}
myCrossAir::~myCrossAir(){
}


void myCrossAir::drawGeometry(){
  
  
  float Xpos =0;
  float Ypos =0;
  float Zpos =0;
  float Radius = 20;
  glLineWidth(2);
  /* draw a circle in X/Z plane from a bunch of short lines */
  float vectorX;
  float vectorX1 = Xpos;
  float vectorZ;
  float vectorZ1 = Zpos + Radius;
  float angle;   
  float initVectorX1,initVectorZ1 ;
  float initXpos,initZpos ;
  
  initXpos = 0;
  initZpos = 0;
  initVectorX1 = 0;
  initVectorZ1 = 0;
  
  glPushMatrix();
  
  glRotatef(90,1,0,0);
  if ( POOP_LIGHTING ) glDisable(GL_LIGHTING);
  glColor3f(1.0, 0.0, 0.0);
  
  glBegin(GL_LINE_STRIP); 
  glVertex3d(Xpos+25,   Ypos, Zpos);
  glVertex3d(Xpos+lines+150, Ypos, Zpos);
  glEnd();
  glBegin(GL_LINE_STRIP); 
  glVertex3d(Xpos-25,   Ypos, Zpos);
  glVertex3d(Xpos-lines-150, Ypos, Zpos);
  glEnd();	
  glBegin(GL_LINE_STRIP); 
  glVertex3d(Xpos, Ypos, Zpos+25);
  glVertex3d(Xpos, Ypos, Zpos+lines+150);
  glEnd();
  glBegin(GL_LINE_STRIP); 
  glVertex3d(Xpos, Ypos, Zpos-25);
  glVertex3d(Xpos, Ypos, Zpos-lines-150);
  glEnd();
  
  
  glBegin(GL_LINE_LOOP); 
  
  for(angle=0.0f;angle<=(2.0f*3.14159);angle+=0.2f)
    { 
      vectorX = Xpos + (Radius*(float)sin((double)angle));
      vectorZ = Zpos + (Radius*(float)cos((double)angle)); 
      glVertex3d(vectorX1,Ypos,vectorZ1);
      vectorX1 = vectorX;
      vectorZ1 = vectorZ; 
    }
  glEnd();
  
  
  
  Radius = 25;
  rotator*=20;
  glRotatef(rotator,0,1,0);
  glBegin(GL_LINE_LOOP); 
  for(angle=0.0f;angle<=(2.0f*3.14159);angle+=0.2f)
    { 
      if (angle == 0) {glColor3f(0.0, 1.0, 0.0); }
      else{	
	vectorX = Xpos + (Radius*(float)sin((double)angle));
	vectorZ = Zpos + (Radius*(float)cos((double)angle)); 
	
	glVertex3d(initVectorX1,Ypos,initVectorZ1);
	initVectorX1 = vectorX;
	initVectorZ1 = vectorZ; 
      }
      
    }
  glEnd();
  
  glPopMatrix();
  
 if ( POOP_LIGHTING )  glEnable(GL_LIGHTING);
}

#endif



