/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Map Object
   We can use this as a base class for Buildings, intersections, etc
   
*/

#ifndef POOP_EM_UP_MAPOBJECT_H
#define POOP_EM_UP_MAPOBJECT_H

#include "../../common.h"
#include "../base/myObject2.h"
#include <list>

#define MAPOBJ_TYPE_PARK 1
#define MAPOBJ_TYPE_BUILDING 2
#define MAPOBJ_TYPE_SIDEWALK 3
#define MAPOBJ_TYPE_ROAD 4

class MapObject : public myObject2
{
 public:
  MapObject() : m_North(0), m_South(0), m_East(0), m_West(0), m_Top(0), m_Bottom(0)
    {IsInPlace = 0;}
  ~MapObject() 
    { 
      glDeleteLists(m_DisplayList, 1);
    }
  
  virtual void SetupDisplayList();
  virtual void drawGeometry();
  
  void setType (int t){type = t;}
  int getType () {return type;}
  // map object is defined by six sides North, South, East, West, Top and Bottom.
  // N/S are in Y axis
  // E/W are in X axis
  // T/B are in Z axis
  
  float m_North, m_South, m_East, m_West;
  float m_Top, m_Bottom;
  
  // These are for the textures
  GLuint m_texNorth, m_texSouth, m_texEast, m_texWest;
  GLuint m_texTop, m_texBottom;
  
  GLuint m_DisplayList;
  
  int IsInPlace;

 private:
  int type;

  
};

/* Create a list type */
typedef list<MapObject*> MAP_OBJ_LIST;

void MapObject::drawGeometry()
{
  // if (displayLists.getWindowId(m_DisplayList) > -1){
  glCallList(displayLists.getList(m_DisplayList));  
  //}  
}

void MapObject::SetupDisplayList()
{
  // this should be set up in the derived class
  cout << "MapObject::SetupDisplaylist got called!" << endl;
}

#endif










