/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Tile class
   Stephen Fink
   Oct 26, 2002
   
   Very basic placeholder for a Tile class for game logic testing
   
*/
#ifndef POOP_EM_UP_TILE_H
#define POOP_EM_UP_TILE_H

#include "../../common.h"
#include "../mapObjects/MapObject.h"

// it is the bits that define the types of things 
#define TILE_INVALID		0x00
#define TILE_SIDEWALK		0x01
#define TILE_BUILDING		0x02
#define TILE_PARK	        0x04
#define TILE_ROAD		0x08
#define TILE_ROAD_EW		0x10
#define TILE_ROAD_NS		0x20

#define MAX_TILE_TYPE		0x40

#define TILE_INTERSECTION   (TILE_ROAD_EW | TILE_ROAD_NS)

#define IS_TILE_TYPE(n,type) (type == (n & type))
#define IS_ONE_OF(n, type) (n & type)

class Tile /* : public myObject2 */
{
 public:
  // Public data
  float m_size;
  int m_TileType;	
  MapObject* m_pMapObject;
  
  // Methods
  Tile(){
    m_TileType = TILE_INVALID;
    m_size = 1;
    m_pMapObject = NULL;
  };
  ~Tile() {}
  
  /* Draw a solid square to represent the tile */
  int GetTileType() {return m_TileType;}
  
};

#endif

















