/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* 
   BUILDING CLASS
*/

#ifndef POOP_EM_UP_MYBUILDING_H
#define POOP_EM_UP_MYBUILDING_H

#include "../../common.h"
#include "../mapObjects/MapObject.h"


class myBuilding : public MapObject
{
 public:
  myBuilding()  {setType(MAPOBJ_TYPE_BUILDING);}
  ~myBuilding() {}
  void setUpBuilding1(); //Rectagulare buildings

  virtual void SetupDisplayList();

};

void myBuilding::SetupDisplayList()
{
  // default draws the cube bounded by N,S,E,W,T,B
  // if you want textures, you'll have to do it before calling myBuilding::drawGeometry
  
  /* greets to fogof for the ascii art idea
         F----E
        /|   /| 
       / |  / |
      B----A  |
      |  G-|--H
      | /  | /
      |/   |/
      C----D     


      Z   Y 
      ^
      |  /
      | /
      |/
      *--->X 
     
     
     ABCD is FRONT face
  */
  
  
  if(!IsInPlace)
    {	
      // use the translation and scaling instead of the 
      translateBy(m_West, m_South, m_Bottom);
      scaleBy(m_East - m_West, m_North - m_South, m_Top - m_Bottom);
      //scaleBy(10,10,10);
      IsInPlace = 1;
    }
  
  glNewList(displayLists.getList(m_DisplayList), GL_COMPILE);
  //Setup up the building in here.
  setUpBuilding1();
  glEndList(); 

  
}

void myBuilding::setUpBuilding1(){

 
  /*
    #define A m_East,m_South,m_Top
    #define B m_West,m_South,m_Top
    #define C m_West,m_South,m_Bottom
    #define D m_East,m_South,m_Bottom
    #define E m_East,m_North,m_Top
    #define F m_West,m_North,m_Top
    #define G m_West,m_North,m_Bottom
    #define H m_East,m_North,m_Bottom
  */
#define A 1,0,1 // m_East,m_South,m_Top
#define B 0,0,1 // m_West,m_South,m_Top
#define C 0,0,0 // m_West,m_South,m_Bottom
#define D 1,0,0 // m_East,m_South,m_Bottom
#define E 1,1,1 // m_East,m_North,m_Top
#define F 0,1,1 // m_West,m_North,m_Top
#define G 0,1,0 // m_West,m_North,m_Bottom
#define H 1,1,0 // m_East,m_North,m_Bottom
  
  glEnable(GL_CULL_FACE);
  glPolygonMode(GL_FRONT, GL_FLAT);
  
  // Front Face (the SOUTH plane)
  
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texSouth);	
  glNormal3f(0,-1,0);
  glBegin(GL_QUADS);
  glTexCoord2f(1.0f, 1.0f);		glVertex3f(A);
  glTexCoord2f(0.0f, 1.0f);		glVertex3f(B);
  glTexCoord2f(0.0f, 0.0f);		glVertex3f(C);
  glTexCoord2f(1.0f, 0.0f);		glVertex3f(D);
  glEnd();	
  glDisable( GL_TEXTURE_2D );
  
  // Back Face (the NORTH plane)
  
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texNorth);	
  glNormal3f(0,1,0);
  glBegin(GL_QUADS);
  glTexCoord2f(1.0f, 1.0f);		glVertex3f(F);
  glTexCoord2f(0.0f, 1.0f);		glVertex3f(E);
  glTexCoord2f(0.0f, 0.0f);		glVertex3f(H);
  glTexCoord2f(1.0f, 0.0f);		glVertex3f(G);
  glEnd();
  glDisable( GL_TEXTURE_2D );
  
  // Top Face (the TOP plane)
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texTop);	
  glNormal3f(0,0,1);
  glBegin(GL_QUADS);
  glTexCoord2f(1, 1);			 glVertex3f(E);
  glTexCoord2f(1, 0.0f);		 glVertex3f(F);
  glTexCoord2f(0.0f, 0.0f);	 glVertex3f(B);
  glTexCoord2f(0.0f, 1);		 glVertex3f(A);
  glEnd();
  glDisable( GL_TEXTURE_2D );
  
  // Bottom Face (the BOTTOM plane)
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texBottom);		
  glBegin(GL_QUADS);
  glTexCoord2f(1.0f, 1.0f);		glVertex3f(H);
  glTexCoord2f(1.0f, 0.0f);		glVertex3f(G);
  glTexCoord2f(0.0f, 0.0f);		glVertex3f(C);
  glTexCoord2f(0.0f, 1.0f);		glVertex3f(D);
  glEnd();
  glDisable( GL_TEXTURE_2D );
  
  // Right face (the EAST plane)
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texEast);	
  glNormal3f(1,0,0);
  glBegin(GL_QUADS);
  glTexCoord2f(1.0f, 1.0f);		glVertex3f(E);
  glTexCoord2f(0.0f, 1.0f);		glVertex3f(A);
  glTexCoord2f(0.0f, 0.0f);		glVertex3f(D);
  glTexCoord2f(1.0f, 0.0f);		glVertex3f(H);
  glEnd();
  glDisable( GL_TEXTURE_2D );
  
  // Left Face (the WEST plane)
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texWest);	
  glNormal3f(-1,0,0);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f);		glVertex3f(B);
  glTexCoord2f(1.0f, 0.0f);		glVertex3f(F);
  glTexCoord2f(1.0f, 1.0f);		glVertex3f(G);
  glTexCoord2f(0.0f, 1.0f);		glVertex3f(C);
  glEnd();
  glDisable( GL_TEXTURE_2D );

#undef A
#undef B
#undef C
#undef D
#undef E
#undef F
#undef G
#undef H
}


#endif
