/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Map Object
   We can use this as a base class for Buildings, intersections, etc
   
*/

#ifndef POOP_EM_UP_MYROAD_H
#define POOP_EM_UP_MYROAD_H

#include "../../common.h"
#include "../mapObjects/MapObject.h"


class myRoad : public MapObject
{
 public:
  myRoad()  {setType(MAPOBJ_TYPE_ROAD);}
  ~myRoad() {}

  virtual void SetupDisplayList();

};

void myRoad::SetupDisplayList()
{
  // draw a park

  // use the translation and scaling instead of the 
	if(!IsInPlace)
	{	
		translateBy(m_West, m_South, m_Bottom);
		scaleBy(m_East - m_West, m_North - m_South, m_Top - m_Bottom);
		IsInPlace = 1;
	}
  //scaleBy(10,10,10);

  glNewList(displayLists.getList(m_DisplayList), GL_COMPILE);

  // Here is where the drawing should begin

  glEnable(GL_CULL_FACE);
  //glPolygonMode(GL_FRONT, GL_FLAT);
  
  // Top Face (the TOP plane)
  glEnable(POOP_TEXTURE_2D);
  glBindTexture( GL_TEXTURE_2D, m_texTop);	
  glNormal3f(0,0,10);
  glBegin(GL_QUADS);
    glTexCoord2f(1, 1);			 glVertex3f(1,1,0);
    glTexCoord2f(1, 0.0f);		 glVertex3f(0,1,0);
    glTexCoord2f(0.0f, 0.0f);	 glVertex3f(0,0,0);
    glTexCoord2f(0.0f, 1);		 glVertex3f(1,0,0);
  glEnd();
  glDisable( GL_TEXTURE_2D );

  glEndList(); 

}

#endif
