/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Movable Object base class (for use in Cars, Pedestrians, etc) 
   Stephen Fink
   Nov 5, 2002
*/

#ifndef POOP_EM_UP_MOVABLEOBJECT_H
#define POOP_EM_UP_MOVABLEOBJECT_H

#include "../../common.h"
#include "../base/myObject2.h"
#include <list>

class MovableObject : public myObject2
{
 public:
  MovableObject() {}
  ~MovableObject() {}
  // fink: --++>> virtual void Update(PoopWorld &theWorld);
  virtual void Move();
  virtual void ChangeDirection(); // default ChangeDirection
  
  /** @dia:route 0,2;h,7,7,-3,8,3 */
  my3dPoint m_location;
  /** @dia:route 0,2;h,7,7,-3,8,3 */
  myVector m_facingDir;
  float m_speed;

  int m_TilesCanWalkOn; // set what type of tiles this object can "walk" on
  int m_BehaviourState; // for use by objects to keep track of their behaviour
  
  my3dPoint m_LocalRotation; 
  my3dPoint m_LocalScaling;

  int rotateObj;
};

/* create a list type */
typedef list<MovableObject*> MOVING_OBJ_LIST;


/* fink: --++>> I'm adding this later, but for now is no good
   void MovableObject::Update(PoopWorld &theWorld)
   {
   // default update tries to move, and changes direction if it can't move
   mt3dPoint test_point;
   test_point = m_location + m_movement;
   if(m_TilesCanWalkOn & theWorld.GetTileTypeFromWorldCoord(test_point.getX(), test_point.getY()))
   Move();
   else
   ChangeDirection();
   }
*/

void MovableObject::Move()
{
  // default movement - just update the location by the 
  // movement 
  translateBy(m_facingDir.getX() * m_speed,
	      m_facingDir.getY() * m_speed,
	      m_facingDir.getZ() * m_speed);
  m_location = m_location + m_facingDir*m_speed;
}

void MovableObject::ChangeDirection() 
{
  // default does nothing

/*** MOVE IN X OR Y DIRECTIO BUT NOT BOTH ***/
  int turnAngle = (1 + rand()%4);
  switch (turnAngle){
    case 1:
        m_LocalRotation.setZ( m_LocalRotation.getZ() + 90);
		rotateObj = 90;
        break;
    case 2:
       m_LocalRotation.setZ( m_LocalRotation.getZ() + 180);
	   rotateObj = 180;
        break;
    case 3:
        m_LocalRotation.setZ( m_LocalRotation.getZ() -90);
		rotateObj = -90;
        break;        
    case 4:
        m_LocalRotation.setZ( m_LocalRotation.getZ());
		rotateObj = 0;
        break;
    }
    m_facingDir.setX(cos(turnAngle*PI/2));
    m_facingDir.setY(sin(turnAngle*PI/2));
    //rotateAroundZBy(m_LocalRotation.getZ());
}

#endif
