/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INTSELECTOR_H
#define INTSELECTOR_H


#include "button.h"
#include "formElem.h"

class intSelector: public formElem{

 private:
  /* A Pointer to the value that will be modified */
  int * value;
  int step;
  char title[BUTTON_DESC_MAX_SIZE];

  int selectZone;  // The buffer zone where the mouse clicks and it selects.

 public:
  void drawGeometryOver();
  void drawGeometryOut();
  void runAction(float mouseX, float mouseY);
 
  void incValue(void);
  void decValue(void);
  void setTitle(char *t){strncpy(title, t, BUTTON_DESC_MAX_SIZE);}

  void setInt(int *t){ value = t;}

  void setSelectZone(int t){selectZone = t;}

  intSelector();
  ~intSelector(){}
};

void intSelector::runAction(float mouseX, float mouseY){
  float x = getX();
  //  float y = getY();
  float w = getWidth();
  //float h = getHeight();
  
  if (mouseX < x + selectZone) decValue();
  if (mouseX > x + w - selectZone) incValue();

  
}
void intSelector::drawGeometryOver(){
  float x = getX();
  float y = getY();
  float padding = getPadding();
  char str[ BUTTON_DESC_MAX_SIZE]="";

  int tVal = *value;
  
  fgColor.r = fgColor.g = fgColor.b = 1;
  fgColor.a = 1;

  sprintf(str, "- | %s: %d | +",title,  tVal);
  setLabel(str);
  glColor4f(fgColor.r,fgColor.g,fgColor.b,fgColor.a);
  printString(x+padding,y+padding+BUTTON_FONT_HEIGHT,getLabel());
}

void intSelector::drawGeometryOut(){
  float x = getX();
  float y = getY();
  float padding = getPadding();
  char str[ BUTTON_DESC_MAX_SIZE]="";
  int tVal = *value;

  fgColor.r = fgColor.g = fgColor.b = 0.75;
  fgColor.a = 1;
  
  sprintf(str, "- | %s: %d | +",title,  tVal);
  setLabel(str);
  glColor4f(fgColor.r,fgColor.g,fgColor.b,fgColor.a);
  printString(x+padding,y+padding+BUTTON_FONT_HEIGHT,getLabel());
  
}

void intSelector::incValue(){
  //cout<<"Called incValue"<<endl;
  *value += step ;
}
void intSelector::decValue(){
  //cout<<"Called decValue"<<endl;
  *value -= step ;
}

intSelector::intSelector(){
  bgColor.r = bgColor.g = bgColor.b = 1;
  bgColor.a = 0.5;
  fgColor.r = fgColor.g = fgColor.b = 0.5;
  fgColor.a = 0.5;
  step = 1;
  selectZone = 20;
}

#endif
