/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/***************************************************************************
									    Nic
***************************************************************************/


#ifndef TEXTURELOADER_H
#define TEXTURELOADER_H

#include "base/myObject2.h"
#include <stdio.h>
#include <stdlib.h>

#define TEXTURE_GRASS 12

class textureLoader : public myObject2  {
 public:
  textureLoader();
  ~textureLoader();
  void drawGeometry();
  void loadTexture() ;
  void loadTextureSky();
  void loadTextureMask();
  void loadTextureCar();
  void loadTexturePed();
  GLfloat getWidth(){ return 1;}
  GLfloat getHeight(){ return 1;}
  GLuint LoadTextureRAW( const char * filename, int wrap, int n );
  void FreeTexture( GLuint texture);
  GLuint texture[29];
  GLuint textmsk[2];
 private:
  
  //data mambers
  
  float MINX,MINY,MAXX,MAXY,HEIGHT;
  int buildingType;
  float U,V,H;
  GLuint startList;
};

textureLoader::textureLoader(){
  
}
textureLoader::~textureLoader(){
}

void textureLoader::loadTexture() {
  /* load an array of texture */
  texture[0]	 = LoadTextureRAW("textures/texture.raw", TRUE ,0);   
  texture[1]  = LoadTextureRAW("textures/texture1.raw",	  TRUE ,1);   
  texture[2]  = LoadTextureRAW("textures/texture2.raw", TRUE ,2);   
  texture[3]  = LoadTextureRAW("textures/texture3.raw",  TRUE ,3);   
  texture[4]  = LoadTextureRAW("textures/texture4.raw", TRUE ,4);   
  texture[5]  = LoadTextureRAW("textures/texture5.raw", TRUE ,5);   
  texture[6]  = LoadTextureRAW("textures/road.raw",TRUE ,6);  
  texture[7]  = LoadTextureRAW("textures/road2.raw",TRUE ,7);   
  texture[8]  = LoadTextureRAW("textures/sidewalk.raw",TRUE ,8);  
  texture[9]  = LoadTextureRAW("textures/intersection.raw",TRUE ,9); 
  texture[12]  = LoadTextureRAW("textures/grass.raw",TRUE ,12); 
  
  
}

void textureLoader::loadTextureSky() {
  texture[10]	 = LoadTextureRAW("textures/skytop.raw",   TRUE ,10);   
  texture[11]	 = LoadTextureRAW("textures/skyside.raw",   TRUE ,11);   
}
void textureLoader::loadTextureMask() {
  textmsk[0]  = LoadTextureRAW("textures/eyesmask.raw",		TRUE ,0);   
  textmsk[1]  = LoadTextureRAW("textures/eyesbang.raw",		TRUE ,1);   
}

void textureLoader::loadTextureCar() {
  texture[13]  = LoadTextureRAW("textures/car_front.raw",TRUE ,13);   
  texture[14]  = LoadTextureRAW("textures/car_back.raw",TRUE ,14);   
  texture[15]  = LoadTextureRAW("textures/car_Top.raw",TRUE ,15);   
  texture[16]  = LoadTextureRAW("textures/car_windshield.raw",	TRUE ,16); 
  texture[17]  = LoadTextureRAW("textures/car_wheel.raw",TRUE ,17);   
  texture[18]  = LoadTextureRAW("textures/car_door2.raw",TRUE ,18);   
  texture[19]  = LoadTextureRAW("textures/car_door.raw",TRUE ,19);   
  texture[20]  = LoadTextureRAW("textures/car_sidewindow.raw",	TRUE ,20); 
}

//GLuint ped_wc_headface, ped_wc_headside,ped_wc_headback,ped_wc_headtop,ped_wc_bodyfront,ped_wc_bodyback, ped_wc_bodymisc;

void textureLoader::loadTexturePed() {
  texture[21]  = LoadTextureRAW("textures/wc_headface.raw",TRUE ,21);   
  texture[22]  = LoadTextureRAW("textures/wc_headside.raw",TRUE ,22);   
  texture[23]  = LoadTextureRAW("textures/wc_headside2.raw",TRUE ,23);   
  texture[24]  = LoadTextureRAW("textures/wc_headtop.raw",TRUE ,24);   
  texture[25]  = LoadTextureRAW("textures/wc_headback.raw",TRUE ,25);   
  texture[26]  = LoadTextureRAW("textures/wc_front.raw",TRUE ,26);   
  texture[27]  = LoadTextureRAW("textures/wc_back.raw",TRUE ,27);   
  
}




void textureLoader::drawGeometry() {
  
}


// load a 256x256 RGB .RAW file as a texture
GLuint textureLoader::LoadTextureRAW( const char * filename, int wrap, int n )
{
  //  GLuint texture;
  int width, height;
  unsigned char * data;
  FILE * file;
  
  // open texture data
  file = fopen( filename, "rb" );
  if ( file == NULL ) return 0;
  
  // allocate buffer
  width = 256;
  height = 256;
  
  data = reinterpret_cast<unsigned char *>( malloc( width * height * 3));
  
  // read texture data
  fread( data, width * height * 3, 1, file );
  fclose( file );
  
  // allocate a texture name
  glGenTextures( 1, &texture[n] );
  
  // select our current texture
  glBindTexture( GL_TEXTURE_2D, texture[n] );
  
  // select modulate to mix texture with color for shading
  glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
  
  // when texture area is small, bilinear filter the closest MIP map
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST );
  // when texture area is large, bilinear filter the first MIP map
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
  
  // if wrap is true, the texture wraps over at the edges (repeat)
  //       ... false, the texture ends at the edges (clamp)
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,GL_REPEAT);
  
  // build our texture MIP maps
  gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width,
		     height, GL_RGB, GL_UNSIGNED_BYTE, data );
  
  // free buffer
  free( data );
  
  return texture[n];
  
}

void textureLoader::FreeTexture( GLuint texture)
{
  
  glDeleteTextures( 1, &texture);
  
}






#endif
