/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Menu function handlers */

#ifndef POOP_EM_UP_MENU_FUNCTIONS
#define POOP_EM_UP_MENU_FUNCTIONS

/* All of these have to be void fn(void)
 */
#include "includes/osd/formElem/intSelector.h"
#include "includes/osd/formElem/checkBox.h"

Menu mainmenu;
Menu configMenu;
Button *configTrees, *configTexture ;
checkBox tempCheckBox;
intSelector gameSpeed;

/*************** MAIN MENU ***************/
void OnMenuQuit(void)
{
	TIMESTAT_REPORT();
	exit(0);
}

void OnMenuStart(void)
{
  // start was clicked
  // Place the bird correctly in the world
  theWorld.bird.moveTo(5000,5000, 1500);
  theWorld.bird.setLookAt(0,0,0);
  theWorld.bird.reset();
  theWorld.StartLevel(currLevel);
  mainmenu.setLabel(":: Main Menu ::");
  mainmenu.disable();
}

void OnMenuNextLevel(void){
  //TODO: put in a next level function in here.
  // and attach it to the menu in the apropriate places.


}

void OnMenuResume(void){
  mainmenu.disable();
}

void OnMenuConfig(void){
  configMenu.enable();
  mainmenu.disable();
}

/*********** CONFIG MENU *****************/

void OnConfigBack(void){
  mainmenu.enable();
  configMenu.disable();
}


void OnConfigSave(void){
  writeConfiguration();
}

/************* INIT MENU *****************/
void InitMenu(){
  formElem *pBut;
  checkBox *pCBox;

  /**** MAIN MENU *****/
  mainmenu.setLabel("MAIN MENU");
  /* Start */
  pBut = mainmenu.CreateButton("  START  ", OnMenuStart);
  pBut->setDescription("Start the game");
  /* Resume */
  pBut = mainmenu.CreateButton(" RESUME  ", OnMenuResume);
  pBut->setDescription("Resume the game");
  /* Config */
  pBut = mainmenu.CreateButton(" CONFIG  ", OnMenuConfig);
  pBut->setDescription("Configure The Game");
  /* Quit */
  pBut = mainmenu.CreateButton("  QUIT   ", OnMenuQuit);
  pBut->setDescription("Quit the game");
  pBut->setOverCursorType(GLUT_CURSOR_DESTROY);

  /******* CONFIG MENU **********/
  configMenu.setLabel("Configuration Options");

  pBut = configMenu.CreateIntSelector("Game Speed",(int *) &POOP_GAME_SPEED);
  pBut->setDescription("Game speed should be around 50~60");

  pCBox = configMenu.CreateCheckBox("Show trees", &POOP_SHOW_TREES);
  pCBox->setDescription("Select to show trees");

  pCBox = configMenu.CreateCheckBox("Show Textures", &POOP_TEXTURE_2D);
  pCBox->setCheckedVal( GL_TEXTURE_2D );
  pCBox->setDescription("Select to use textures");

  pBut = configMenu.CreateCheckBox("Show clouds", &POOP_SHOW_CLOUDS);
  pBut->setDescription("Selected to show clouds.");
 
  pBut = configMenu.CreateButton("   Save    ", OnConfigSave);  
  pBut = configMenu.CreateButton(" Main Menu ", OnConfigBack);

 
}


#endif
