/* Poopmup - An urban flight sim
 *
 * Copyright (C) 2002 Zaroubi, Fink, Leclerc, Stanek szaroubi@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MYCONFIG_H
#define MYCONFIG_H

#define POOP_CONF_FILE "config/poopmup.config"
#include <fstream>
#include "common.h"

int equal(const char* a, const char * b)
{
  return (0 == (strcmp(a , b)));

}

void writeConfiguration(){
  ofstream confFile;

  confFile.open (POOP_CONF_FILE, ofstream::out );

  confFile<<"FAST_CONPUTER"    <<endl<<FAST_COMPUTER<<endl<<endl;
  confFile<<"POOP_SHOW_CLOUDS" <<endl<<POOP_SHOW_CLOUDS<<endl<<endl;
  confFile<<"POOP_SHOW_TREES"  <<endl<<POOP_SHOW_TREES<<endl<<endl;
  confFile<<"POOP_WINDOW_MODE" <<endl<<POOP_WINDOW_MODE<<endl<<endl;
  confFile<<"POOP_LIGHTING"    <<endl<<POOP_LIGHTING<<endl<<endl;
  confFile<<"POOP_TEXTURE_2D"  <<endl<<POOP_TEXTURE_2D<<endl<<endl;
  confFile<<"POOP_SHADING_TYPE"<<endl<<POOP_SHADING_TYPE<<endl<<endl;
  confFile<<"POOP_GAME_SPEED"  <<endl<<POOP_GAME_SPEED<<endl<<endl;
  
  confFile.close();
}

void getConfiguration (){

  //Open the file.
  ifstream confFile(POOP_CONF_FILE);
  char buffer[80];
  
  //Get a line and put it into buffer.
  while (confFile.getline (buffer, 80)){
  
    /**
     * compare that line to expected arguments
     */
    //cout <<buffer << ";"<<endl;
    if (equal(buffer, "FAST_COMPUTER")){
      confFile.getline(buffer, 80);
      FAST_COMPUTER = atoi(buffer);
    }
    
    if (equal (buffer, "POOP_SHOW_CLOUDS")){
      confFile.getline(buffer, 80);
      POOP_SHOW_CLOUDS = atoi(buffer);
    }

    if (equal (buffer, "POOP_WINDOW_MODE")){
      confFile.getline(buffer, 80);
      POOP_WINDOW_MODE = atoi(buffer);
    }

    if (equal (buffer, "POOP_SHOW_TREES")){
      confFile.getline(buffer, 80);
      POOP_SHOW_TREES = atoi(buffer);
    }

    if (equal (buffer, "POOP_LIGHTING")){
      confFile.getline(buffer, 80);
      POOP_LIGHTING= atoi(buffer);
    }
    
    if (equal (buffer, "POOP_TEXTURE_2D")){
      confFile.getline(buffer, 80);
      if (atoi(buffer) == 0)
	POOP_TEXTURE_2D = 0;
      else if (atoi(buffer) == 1)
	POOP_TEXTURE_2D = GL_TEXTURE_2D;
    }    

    if (equal (buffer, "POOP_GAME_SPEED")){
      confFile.getline(buffer, 80);
      POOP_GAME_SPEED = atoi(buffer);
	  if(POOP_GAME_SPEED == 0) 
		  POOP_GAME_SPEED = 60;
    }

    if (equal (buffer, "POOP_SHADING_TYPE")){
      confFile.getline(buffer, 80);
      switch (atoi(buffer)){
      case 0:
	POOP_SHADING_TYPE = 0;
	break;
      case 1:
	POOP_SHADING_TYPE = GL_FLAT;
	break;
      case 2:
	POOP_SHADING_TYPE = GL_SMOOTH;
	break;
      }
    }
    
  }/* END OF READING CONFFILE */
}



#endif
